Unit MLU27_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMN13_p, MLU08_p, MLU02_p;

procedure MLU27(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; N :Integer; var K :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer; EPS :Real;
                var AMS :Array of Integer);

implementation

procedure MLU27(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; N :Integer; var K :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer; EPS :Real;
                var AMS :Array of Integer);
var
L,K1,K2,K3,KA,J :Integer;
DEL,DEL1,TO1 :Real;
const
O16000 :Integer = 16000;
label
_2,_4,_3,_1;
begin
{        OCK BBOMOO CTOA  AA }
{        C BEPXHM OPAHEHM HA EPEMEHHE }
{        B BPOEHHOM CYAE. MATPA XPAHTC EKOM. }
MIN := 0.0;
K3 := 0;
K1 := 1;
for J:=1 to N do
 begin
  UTMN13(J,AMS,KA);
  if ( KA = 1 ) 
   then goto _1;
_2:
  if ( K1 > KV )
   then goto _4;
  K2 := NALFA[K1-1];
  K3 := K2;
  if ( K2 > O16000 )
   then K3 := K2-O16000;
  if ( J <= K3 )
   then goto _4;
  K1 := K1+1;
  goto _2;
_4:
  MLU08(U,M,A,N,J,DEL);
  MLU02(U,M,A,N,J,DEL1);
  if ( Abs(DEL1) >= EPS )
   then goto _1;
  if ( J <> K3 )
   then goto _3;
  if ( K2 > O16000 )
   then DEL := -DEL;
_3:
  if ( DEL >= MIN )
   then goto _1;
  MIN := DEL;
  K := J;
_1:
 end;
end;

end.
