Unit MLU33_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLU33(var TETA :Real; var L :Integer; K :Integer;
                var XK :Array of Real; M :Integer;
                var ALFA :Array of Real; KV :Integer; NA :Integer;
                var NALFA :Array of Integer;
                var NX :Array of Integer);

implementation

procedure MLU33(var TETA :Real; var L :Integer; K :Integer;
                var XK :Array of Real; M :Integer;
                var ALFA :Array of Real; KV :Integer; NA :Integer;
                var NALFA :Array of Integer;
                var NX :Array of Integer);
var
I,I1,K1 :Integer;
X :Real;
const
O16000 :Integer = 16000;
label
_6,_1,_7,_2,_3,_4,_5;
begin
{        KOPPEKTPOBKA HOMEPOB EPEMEHHX, }
{        BEX HA BEPXH PAHY. }
if ( L = 0 ) 
 then goto _4;
if ( L < O16000 )
 then goto _6;
TETA := -TETA;
L := L-O16000;
if ( L = 0 )
 then goto _2;
_6:
if ( XK[L-1] > 0 )
 then goto _7;
for I:=1 to KV do
 begin
  I1 := NALFA[I-1];
  K1 := NX[L-1];
  if ( I1 <> K1 )
   then goto _1;
  I1 := I1+O16000;
  NALFA[I-1] := I1;
_1:
 end;
_7:
if ( TETA >= 0.0 )
 then goto _4;
_2:
for I:=1 to M do
 begin
_3:
  XK[I-1] := -XK[I-1];
 end;
_4:
K1 := K;
if ( NA = 0 )
 then goto _5;
if ( TETA >= 0 ) and ( L = 0 )
 then K1 := K+O16000;
if ( TETA < 0 ) or ( L = 0 )
 then NALFA[NA-1] := K1;
_5:
end;

end.
