Unit ML04R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLU01_p, UTMN12_p, MLU26_p, MLU31_p, MLU27_p, MLU04_p, MLU32_p,
MLU33_p, MLU18_p, MLU07_p, MLU35_p;

procedure ML04R(var A :Array of Real; M :Integer;
                var U :Array of Real; N :Integer;
                var X :Array of Real; var P :Integer; EPS :Real;
                var AMS :Array of Integer; var XK :Array of Real;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer;
                var NX :Array of Integer);

implementation

procedure ML04R(var A :Array of Real; M :Integer;
                var U :Array of Real; N :Integer;
                var X :Array of Real; var P :Integer; EPS :Real;
                var AMS :Array of Integer; var XK :Array of Real;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer;
                var NX :Array of Integer);
var
I,K,NI,NE,M1,I1,L,NA :Integer;
MIN,TETA :Real;
const
O10T10 :Real = 10.0E10;
label
_3,_2,_4,_5,_6,_7,_8,_9,_10,_11,_12,_14,_15,_100,_200,_300,_16;
begin
{        POPAMMA, AHOHA ML03R. }
{        B OTE OT ML03R MATPA }
{        YCOB XPAHTC EKOM.KO- }
{        EHT HEHO OPM XPAHTC }
{        B (M-1)-O CTPOKE MACCBA A(M,N). }
{        B M-TO CTPOKE MACCBA A(M,N) }
{        XPAHTC MHYC CYMM EMEHTOB }
{        CTOOB (C 1-O O (M-2)-Y }
{        CTPOK). }
if ( P <> 1 )
 then goto _2;
for I:=1 to N do
 begin
_3:
  A[(M-2)+(I-1)*M] := -A[(M-2)+(I-1)*M];
 end;
_2:
MLU01(U,M);
for I:=1 to M do
 begin
  K := N+I;
_4:
  NX[I-1] := K;
 end;
for I:=1 to N do
 begin
_5:
//  UTMN12(0,AMS);
  UTMN12(I,AMS);
 end;
NI := 0;
NE := 1;
_6:
MLU26(MIN,U,M,A,N,K,ALFA,KV,NALFA,AMS);
goto _9;
_7:
MLU31(MIN,U,M,A,N,K,ALFA,KV,NALFA,AMS);
goto _9;
_8:
MLU27(MIN,U,M,A,N,K,ALFA,KV,NALFA,EPS,AMS);
_9:
if ( MIN < (-EPS) )
 then goto _12;
case NE of
 1: goto _10;
 2: goto _100;
 3: goto _100;
end;
_10:
NE := 2;
M1 := M-2;
for I:=1 to M1 do
 begin
  I1 := NX[I-1];
  if ( I1 > N )
   then NE := 3;
_11:
 end;
if ( NE = 3 ) and ( X[M-1] < (-EPS) )
 then goto _200;
case NE of
 1: goto _6;
 2: goto _7;
 3: goto _8;
end;
_12:
MLU04(U,M,A,N,K,XK);
MLU32(X,M,XK,K,L,TETA,NX,EPS,
           ALFA,KV,NA,NALFA);
if ( TETA = O10T10 )
 then goto _300;
MLU33(TETA,L,K,XK,M,
ALFA,KV,NA,NALFA,NX);
_14:
MLU18(X,XK,M,K,L,TETA,ALFA,KV,NA);
if ( L = 0 )
 then goto _15;
MLU07(U,M,XK,L);
MLU35(NX,M,K,L,A,N,AMS);
_15:
NI := NI+1;
{       PRINT 20,NI,NE,K,L,NA,MIN,TETA,X(61),X(62) }
{   20 FORMAT(2X'NI,NE,K,L,NA,MIN,TETA,X(61),X(62)'/1X,5I6,5E10.3) }
case NE of
 1: goto _6;
 2: goto _7;
 3: goto _8;
end;
_100:
if ( P <> 1 )
 then X[M-2] := -X[M-2];
P := 1;
goto _16;
_200:
P := 2;
goto _16;
_300:
P := 3;
_16:
end;

end.
